﻿<?php
/**
 *	/Lib/Action当中的function，有public声明的，其他action引用使用；有private声明的，自身使用；否则，输出使用；
 */
if (!defined('THINK_PATH')) exit();

return array(
	'APP_DEBUG' => false, 
	'DEBUG_MODE'=> false,
	'URL_CASE_INSENSITIVE' =>   true,	
	'URL_ROUTER_ON' =>   true,
	'DEFAULT_MODULE'=>'index',
	'DB_FIELDS_CACHE'=>false,
	'DB_TYPE'=>'sqlite',
	'DB_NAME' => 'Index.sqlite',
//	'DB_NAME' => 'D:\www\mock examination\sqlite\Index.sqlite',
//	'DB_NAME' => 'D:\wamp\apps\sqlitemanager1.2.0\Index.sqlite',	
	'DB_PREFIX'=>'',
	'URL_MODEL'=>3,
	'ERROR_PAGE'=>$_SERVER['DOCUMENT ROOT']."/50x.html",
	
	'PAGE_ROLLPAGE'=>1,
	'TOKEN_ON'=> false,	
	
  	'TMPL_TEMPLATE_SUFFIX'  => '.php',
  	'USER_AUTH_KEY' => md5(date("Y-m-d")),
	'HTML_FILE_SUFFIX' => ".html",  	
	'TMPL_CACHE_ON'			=> false,        
	//加载语言包
	'LANG_SWITCH_ON' => true,
    'DEFAULT_LANG' => 'zh-cn', // 默认语言
    'LANG_AUTO_DETECT' => true, // 自动侦测语言
	
	
	
	'UNIT_LEVELS'=>20,
	'SINGLE_UNIT_TAG'=>true,
	'MY_PUBLIC'=>'cdel_qz_zk/',		//public
	'DEFAULT_THEME'=>'cdel_qz_zk',	//tpl
	
	'JUDGE_TYPE'=>array(
		'0'=>'不判分（主观题）',
		'1'=>'直接与答案对比（选择题single_choice\choice、判断题judge）',
		'5'=>'间接与答案对比（填空fill_blanks、按配置选择conf_choice）',
		'2'=>'按提供的配置文件（word、excel、windows）',
		'3'=>'直接返回分数（flash题）',
		'4'=>'混合类型（大题套小题）',
	),
	
	'UNIT_LEVELS'=>100,		//知识点准许的层级
	
	'UPPER_NUM'=>array(
		'1'=>'一',
		'2'=>'二',
		'3'=>'三',
		'4'=>'四',
		'5'=>'五',
		'6'=>'六',
		'7'=>'七',
		'8'=>'八',
		'9'=>'九',
		'10'=>'十',
		'11'=>'十一',
		'12'=>'十二',
		'13'=>'十三',
		'14'=>'十四',
		'15'=>'十五',
		'16'=>'十六',
		'17'=>'十七',
		'18'=>'十八',
		'19'=>'十九',
		'20'=>'二十',
		'21'=>'二十一',
		'22'=>'二十二',
		'23'=>'二十三',
		'24'=>'二十四',
		'25'=>'二十五',
		'26'=>'二十六',
		'27'=>'二十七',
		'28'=>'二十八',
		'29'=>'二十九',
		'30'=>'三十',
		
	),
	
	'CHECK_HOST' => true,		//是否检测本地启动
	
	'DEFAULT_URL_TAG'=>true,	//是否开启默认url
	'SINGLE_UNIT'=>true,		//单知识点标记
	'CD_SOFT'=>'soft',			//光盘或软件
	
	'WEEK'=>array("日","一","二","三","四","五","六"),
	
//	'PERCENT_RIGHT_METHOD'=>'small',	//默认big：以大题为单位；small：以小题为单位
	
	'MOCK_SWITCH'=>true,
	
	
	
	//下面是新加的参数——有库移到此处
	'ARTICLE_TYPE'=>array(
		0=>'系统说明',
		1=>'科目说明',
	),
	'BANK_TYPE'=>array(
		1=>'单项选择题',
		2=>'多项选择题',
		3=>'判断题',
		4=>'简答题',	//主观题
		5=>'阅读理解',	//大题套小题
		6=>'实务操作',	//flash
		7=>'windows',
		8=>'word',
		9=>'excel',
//		10=>'填空题',
	),
	'BANK_SHOW_TYPE'=>array(
		1=>'按大题展示',
		2=>'按小题展示',
	),
	'MENU_TYPE'=>array(
		0=>'父级',
		1=>'文章',
		2=>'链接',
		3=>'模考',
		4=>'其他',
	),
	
	'BANK_VIEW_TITLE'=>array(
		'1'=>'单选题',
		'2'=>'多选题',
		'3'=>'判断题',	
		'4'=>'简答题',
		'5'=>'阅读理解',
		'6'=>'计算题',
		'8'=>'综合题',
		'10'=>'阅读判断',
		'11'=>'概括大意',
		'12'=>'完形填空',
		'13'=>'填空题',
		'14'=>'英语作文',
		'15'=>'英语新题型',
		'16'=>'英语英译汉',
		'17'=>'英语汉译英',
		'18'=>'英语补全短文',
		'19'=>'考研解答题',
		'20'=>'考研分析题',
		'21'=>'不定项题（一）',
		'22'=>'不定项（二）',
		'23'=>'案例分析',
		'25'=>'实务操作题一',
		'26'=>'实务操作题二',
		'27'=>'实务操作题三',
		'28'=>'实务操作题四',
		'29'=>'实务操作题五',
		'30'=>'中文录入题',
		'31'=>'计算分析题',
		'32'=>'配伍选择题',
		'33'=>'解答题',
		'34'=>'综合题4',
		'35'=>'考研解答题',
		'36'=>'考研分析题',
		'37'=>'论述题',
		'38'=>'辨析题',
		'39'=>'法条分析题',
		'40'=>'案例分析题',
		'41'=>'计算题1',
		'42'=>'计算题2',
		'43'=>'综合题1',
		'44'=>'计算分析题',
		'45'=>'计算分析2',
		'46'=>'综合分析题',
		'47'=>'综合题2',
		'48'=>'不定项选择题',
		'49'=>'不定项选择题（二）',
		'50'=>'综合题3',
		'51'=>'综合题4',
		'52'=>'阅读理解1',
		'53'=>'阅读理解2',
		'54'=>'简答题2',
		'55'=>'简答题3',
		'56'=>'简答题4',
		'57'=>'辅助讲解',
		'58'=>'简答题',
		'59'=>'简答题2',
		'60'=>'简答题3',
		'61'=>'综合题',
		'62'=>'综合题2',
		'63'=>'计算问答题',
		'64'=>'计算问答题2',
		'65'=>'综合题3',
		'66'=>'综合题4',
		'67'=>'计算分析题',
		'68'=>'不定项选择(一)',	
		),
	/**
	 * 容错分数处理
	 */	
	'NAGETIVE_SCORE'=>array(
		'value'=>100, // 此值和switch成对出现,相同则为开启,不同则为关闭
		'switch'=>1, //关闭，1开启
		'normal_score' =>0.5,//普通题
		'special_score'=>2.5 //大题套小题里的试题
		),
	/**
	 * 错题记录显示
	 * 1.显示答错的题。
	 * 0.显示答错的题和没有做的题。
	 */
	'WRONG_RECORD'=>array(
		'wrong_value'=>1
	),
	/**
	 *大题套小题中的正确试题是否显示
	 *
	 *
	 */
	'NEWYEAR'=>2016,
	'VERIFY_FILE'=>'test.log',//加密文件名
	'VERIFY_CODE'=>'mo0uw0447werfh8wf6234704',//加密字符串
	
);
?>