(function () {
    var API = function () { };
    API.prototype._tab = null;
    API.prototype._tabContainer = null;
	
    //ӱǩҳΪʾ
    //
    //[
    //  ['Ҫ(1)', '<span>content1</span>', true, ''],
    //  ['Ҫ(2)', '<div contenteditable="true">content2</div>', false, '']
    //]
    //0: ʾڱǩҳϵơ
    //1: HTML
    //2: Ƿɱ༭
	//3: HTML
    API.prototype.AddTabs = function (vbTabs) {
		//var a = new VBArray(vbTabs); 
		var tabs = vbTabs;//a.toArray();
        var _ = this;
        _.ClearTabs();
		//5tabʱtab빤߷ʾ
		
		if(tabs.length > 5)
			_._tab.parent().addClass('twoRowBar');
		else 
			_._tab.parent().removeClass('twoRowBar');
		
		var tabRows = tabs.length <= 15? 1 : (parseInt((tabs.length - 15) / 14) + 1 + ((tabs.length - 15) % 14 != 0? 1: 0));
		_._tab.height(tabRows * 28 + "px");
		_._tab.parent().height((((tabs.length > 5? 1 : 0) + tabRows) * 28) + "px");

			
        $.each(tabs, function (i, n) {
//            var tabItem = $('<li><a href="javascript:void(0);"></a></li>');
            var tabItem = $('<li class="normal">\
	                            <b>\
	                                <span class="tabscenter"><span class="tabsleft"><span class="tabsright"></span></span></span>\
	                            </b>\
	                        </li>');
            var tabContainer = $('<div class="tabDiv"><div class="queTitle" /><div class="queContent" /></div>');

			//var tn = new VBArray(n);
			var item = n;//tn.toArray();
			
            tabItem
                .attr('idx', i)
                .find('span.tabsright')
                .text(item[0]);

            tabItem.find('span.tabsright').click(function () {
                var idx = $(this).parents('li').attr('idx');
                _._tab
                    .find('li.current')
                    .removeClass('current')
					.addClass('normal')
                    .end()
                    .find('li:eq(' + idx + ')')
                    .removeClass('normal')
                    .addClass('current');

                _._tabContainer.children('div.tabDiv').hide();
                _._tabContainer.children('#div_editor_' + idx).show().focus();

				//ָʱʹԭʽɱ༭
				var maths = _._tabContainer.children('div.tabDiv:eq(' + idx + ')').find('.queContent').find("span.isFormula");
				$.each(maths, function(i, n){
					var m = $(n),
						latex = m.attr("latex");
					if(latex != null){
						m
						.after('<span id="span_Temp"></span>&nbsp;')
						.html('')
						.removeClass('mathquill-rendered-math mathquill-editable')
						.data("isEditable", true)
						.mathquill('editable')
						.find("textarea")
						.css("margin-left", "-99999px");
						
						$('#span_Temp').remove();
						try{
							m
							.mathquill('write', latex);
						}
						catch(e){}
						m.removeAttr('latex');
					}
				});
				_._setHeight();
                _.Events.TabChanged && _.Events.TabChanged('div_editor_' + idx);
				window.parent.document.body.scrollTop = 0;	//лtab󣬹ص
            }).mouseover(function(){
				$(this).css('color', '#3066CC');
			}).mouseleave(function(){
				$(this).css('color', '');
			});

            _._tab.append(tabItem);

            tabContainer.attr('id', 'div_editor_' + i);
			tabContainer.children('.queContent')
                .html(item[1])
                .attr('contenteditable', item[2])
				.bind('keydown', function(e){
					var ev = (e || event);
					var keyCode = ev.keyCode || ev.which || ev.charCode;
					if(keyCode === 39)
						Editor._rightArrowDown();
					if(keyCode === 8 && !$.browser.msie){
						var rv = Editor._backspace();	
						rv && (ev.preventDefault ? ev.preventDefault(): ev.returnValue = false);
					}
					
					if((ev.altKey)&&(keyCode==13)){
						ev.keyCode = 37;     // or 39
						ev.returnValue = false;
					}
				})
				.bind('keyup', function(e){
					var ev = (e || event);
					var keyCode = ev.keyCode || ev.which || ev.charCode;
					if(keyCode === 39)
						Editor._rightArrowUp();
						
					_.SaveQent();
				})
				.bind('dragend', function(){
					_.SaveQuesContent();
				})
				.bind('copy', function(){
					Editor.Copy();
					return false;
				})
				.bind('paste', function(e){
					return false;
				})
				.bind('beforepaste', function(e){
					//ֻı
					Editor.Paste();
					return false;
				});
				
			tabContainer
				.children('.queTitle')
				.html(item[3]);

            _._tabContainer.append(tabContainer);
        });
		
        //һtab
        _._tab.find("li:eq(0)").find('span.tabsright').click();

        //_._setHeight();

        return _;
    };
	
	//ջ
	API.prototype._stackPop = function(stack){
		 if(stack.length!=0)
			stack.length --;		 
		 return stack
	};
	
	//ӹʽȡNθsqrt[n]{abc}Ϊ nthroot{n}{abc}
	API.prototype._latexNthroot = function(latex){
		var _ = this;
		var sqrt = '\\sqrt[',
			idx = 0,
			bracketStack = [],	//{s:0, e:5}
			stackTop = -1,
			pairs = [],			//ԣͼƼ
			allBrackets = [];	//Ҫ滻Ŷλ
			
		if(!latex)
			return '';
			
		$.each(latex, function(i, n){
			idx = n == sqrt[idx] ? idx + 1: 0;
			
			if(idx == 6){
				bracketStack.push({
					s: i,
					e: 0
				});
				pairs[++stackTop] = 1;
				idx = 0;
			}else if(stackTop >= 0){
				if(n === '[')
					pairs[stackTop]++;
				else if(n === ']')
					pairs[stackTop]--;
				
				if(pairs[stackTop] === 0){
					bracketStack[stackTop].e = i;
					allBrackets.push(bracketStack[stackTop]);
					bracketStack = _._stackPop(bracketStack);
					stackTop --;
				}
			}
		});
		
		if(allBrackets.length > 0){
			latex = latex.replace(/\\sqrt\[/g, '\\trqs[');
			
			$.each(allBrackets, function(i, n){
				latex = latex.slice(0, n.s) + '{' + latex.slice(n.s + 1);
				latex = latex.slice(0, n.e) + '}' + (n.e < latex.length? latex.slice(n.e + 1): '');
			});
			
			return latex.replace(/\\trqs/g, '\\nthroot');
		}
		
		return latex;
	};

    API.prototype.GetTabs = function () {
        var _ = this;
        var lis = _._tab.find('li');
        var rValues = '';
		var maths = _._tabContainer.find('.queContent').find("span.isFormula");
		$.each(maths, function(i, n){
			var me = $(n);
			me.attr('latex', _._latexNthroot(me.mathquill('latex')));
		});
		
        lis.each(function (i, item) {
            rValues += _._tabContainer.find('div.tabDiv:eq(' + i + ') > .queContent').html() + '|~@~|';
        });
		
		$.each(maths, function(i, n){
			$(n).removeAttr('latex');
		});
		//ΪVBSʹJS飬Էַ
        return rValues.length > 0? rValues.substring(0, rValues.length - 5) : '';
    };

    API.prototype.ClearTabs = function () {
        var _ = this;
        _._tab.find('li').remove();
        _._tabContainer.html('');
    };

    API.prototype._setHeight = function () {
        var _ = this;
		var container = _._tab.parent().parent();
		var tc = _._tabContainer;
		var idx = _._tab.find('li.current').attr('idx');
        tc.height((container.height() - _._tab.parent().height() - 9) + 'px');
		var tabDiv = tc.children('div.tabDiv:eq(' + idx + ')');
		var t = tabDiv.children('.queTitle'), c = tabDiv.children('.queContent');
		
		c.height((tc.height() - t.outerHeight(true) - 10) + 'px');
    };

    //ѡǩ¼
    API.prototype.Events = {
        TabChanged: null
    };
	
	API.prototype.SaveQuesContent = function(){
		try{
			setTimeout(function(){
				//window.external.SaveQuesContent();
			}, 50);
		}catch(e){}
	};

    //ʼ
    API.prototype.Init = function (tabId, tabContainerId) {
        var _ = this;
        _._tab = $('#' + tabId);
        _._tabContainer = $('#' + tabContainerId);

        $(window).resize(function () {
            _._setHeight();
        });

        return _;
    };
	
	API.prototype.HideMatrix = function(){
		$('#div_Matrix').parent().hide();
	};
	
	API.prototype.GetTabBarHeight = function(){
		return this._tab.parent().outerHeight(true);
	};
	
	API.prototype.SetWindowStateButton = function(text){
		var btn = $('#btn_WindowZoom');
		btn.html('<i>&nbsp;</i>' + text);
		
		btn.parent()
			.removeClass('smaller larger')
			.addClass({
				'Ŵ󴰿': 'larger',
				'ָ': 'smaller'
			}[text]);
	};
    window.API = new API();
})()