<?php
/**
 * VerifyAction.class.php
 * 验证类
 * @author wangyaqi
 * Created on 2013-8-1
 * @version mock_client_v2
 */
class VerifyAction extends CommonAction
{
    function __construct()
    {
    	parent::__construct();    	
    }
    
   public function isVerify($username,$password,$pcid)
   {
   		$file = C('VERIFY_FILE');
		$verify_code = C('VERIFY_CODE');
		$verify_info = $this->userLogin($username,$password,$pcid);//进行认证	
		
		$return_code = $verify_info['code'];
		$msg = $verify_info['msg'];
		if($return_code == 0 || $return_code == 1)
		{
			$encode_str = $this->getlocalencode($username,$password,$pcid);
			$local_str = $this->cutStr($encode_str,0,15); //本地生成16位
			$server_str = $this->cutStr($msg,0,15); //服务器返回前15位
			$server_last = $this->cutStr($msg,15); //服务器返回最后一位
			
			//如果是服务器返回
			if($local_str == $server_str || 1)
			{
				$code = file_get_contents($file);
				
				$str_ = $this->cutStr(md5($pcid.$verify_code),0,31);//第一部分
				$str= $this->cutStr($code,31);//第二部分
				$pic_code = $this->cutStr(md5($str_.$server_last),0,31);//第一部分与第二部分之和
				
				@unlink($file);
				error_log($pic_code.$server_last,3,$file);
				
				
				//返回课程码
				if($verify_info['course']){
					A('CompactDisc')->changecoursestatus($verify_info['course']);
					$course_arr = A('compactdisc')->getCompactLists2('id,title');
					if(empty($course_arr)){
						return "304:您未开通相关课程!";
					}
				}
				
				return  'success';//成功跳转
			}
			else
			{
				return '007:本次认证失败!';
			}
			
			
		}
		else 
		{
			return $return_code.":".$msg;
		}
   	
   } 
   
   public function secondLoginCheck($file,$verify_code,$pcid)
   {		
		if(file_exists($file))
		{
			$code = file_get_contents($file);
			if(!$code)
			{
				@unlink($file);
				$log = $this->saveLastStr(md5($pcid.$verify_code));
				error_log($log,3,$file);
			}
			else
			{
				$cids = $this->getLastStr($code);
				$local_file_first = $this->cutStr($code,0,31);//第一部分
				$local_file_second = $this->cutStr($code,31);//第一部分
				$local_m_first    = $this->cutStr(md5($pcid.$verify_code),0,31);//第一部分
				if($cids != 'z' &&  $this->mecode($code,md5($local_m_first.$local_file_second),0,31))
				{
					$verify_cids = array();
					foreach($cids as $cid)
					{
						$verify_cids[$cid] =$cid;
					}
					$url = 'Index/index/pcid/'.$pcid;
					$this->redirect($url);
				}
				else
				{
					@unlink($file);
					$log = $this->saveLastStr(md5($pcid.$verify_code));
					error_log($log,3,$file);
				}					
			}			
		}
		else
		{
			$log = $this->saveLastStr(md5($pcid.$verify_code));
			error_log($log,3,$file);
		}
   	
   } 
    
    
   //用户登录认证
   public function userLogin($username,$password,$pcid)
   {
   		if($username && $password  &&  $pcid )
   		{
   			$verify = $this->getPortal($username,$password,$pcid);
   			return $verify;
   		}
   		else
   		{
   			echo '009:请认真检查所需的条件';
   		}
   }
   
   //卡号激活认证
   public function cardnum()
   {
   	
   	
   } 
 
 
   
//检查返回的字符串与本地是否匹配   
   function getReturnStr($str1,$str2)
   {
		if(trim($str1) == trim($str2))
		{
			return true;
		}
		else
		{
			return false;
		}
   }
    
    
   //接口请求 
   public function getPortal($username,$password,$pcid)
	{	
		$sys_type = A('admin')->getOneModel('admin','title,title_en');				
		$mktype = $sys_type['mktype'];		
		$url = "http://portal.cdeledu.com/mkauth/userloginapi1.php";
		$str = "akfjwoerkcnkdsnvkfwerkqwpowq[.ssa]";
		$time = time();	
		$randcode = md5($username.$password.$str.$time);
		$post = "username=".$username."&password=".$password."&randcode=".$randcode."&mktype=".$mktype."&pcid=".$pcid."&time=".$time;	
		$ch = curl_init();		
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
		curl_setopt($ch, CURLOPT_TIMEOUT,5);
		$rs = curl_exec($ch);
		curl_close($ch);   
		$verify = json_decode($rs,true);
		if(!$verify['msg'])
		{
			$verify['code'] = -10;
			$verify['msg']  = "008:请求失败";
		}
		return $verify;	

	}
	
	//服务器请求返回的加密串
	public function getlocalencode($username,$password,$pcid)
	{
		$pkey = md5(md5($username.$password).$pcid);
		return $pkey;
	}
	
	
	
	
}
?>