//控制做题页面和题目列表页面的显示与隐藏
function initQues(entryFlag){
	if(entryFlag != 1){
		$("#footerDiv").css("display","none");
		$("#quesTitle").css("display","none");
		$("#quesDiv").css("display","none");
	}else{
		$("#footerDiv").css("display","");
		$("#quesTitle").css("display","");
		$("#quesDiv").css("display","");
	}
}

//显示入口的题型说明
function initDirectory(entryFlag){
	if(entryFlag == 1){
		$("#quesMenu").css("display","block");
	}else{
		$("#quesMenu").css("display","none");
	}
}

//打开系数表
function xishuInfo(){
    $("#wrap_xishu_div").css("display","");
}

//关闭系数表
function closexishuInfo(){
	$("#wrap_xishu_div").css("display","none");
}

//矩阵
function showMatrix(){
	$("#box_div_editor_client1").css("display","block");
}

//打开自定义矩阵
function SelfMatrixjs(){
	var selfMatrix=$("#selfMatrix");
	selfMatrix.css("display","");
}

//提交自定义矩阵
function submitSelfMatrix(){
	var arg1=$("#selfRow").val();
	var arg2=$("#selfCol").val();
	InsertMatrix(arg1,arg2);
	$("#selfMatrix").css("display","none");
}

//关闭自定义矩阵
function closeSelfMatrix(){
	$("#selfMatrix").css("display","none");
}

//查看考生信息
function showUserInfo(flag){
	if(flag==0){
		$("#userDiv").css("display","none");
	}else if(flag==1){
		$("#userDiv").css("display","block");
	}
}

//关闭考生信息
function closeUserInfo(){
	$("#userDiv").css("display","none");
}

//查看答案
function viewAnswer(_currConText){
	var commonInfo = strToJson(paperShow.getCommonInfoStr());
	$("#needCache").val(commonInfo['needCache']);
	$("#createType").val(commonInfo['createType']);
	$("#paperViewID").val(commonInfo['paperViewID']);
	$("#siteCourseID").val(commonInfo['siteCourseID']);
	$("#paperScoreID").val(commonInfo['paperScoreID']);
	$("#frmExam1").attr("target", "_blank");
	$("#frmExam1").attr("action", _currConText+"/create/examCenter/examCenter_createPaper.action");
	$("#frmExam1").submit();
}

//主观题过滤
function acountingTextareaContent(content){
	var rtVal=content.replace(/&nbsp;/g," ");
	return rtVal;
}

//计算器
function showCalc(){
	if($("#calc").css("display")=="none"){
		$("#calc").css("display","");
	}else{
		$("#calc").css("display","none");
	}
}

//系数表切换
function showRequirment(type){
	if(type==1){
		$("#tab_"+type).css("display","");
		$("#tab_2").css("display","none");
		$("#tab_3").css("display","none");
		$("#tab_4").css("display","none");
	}else if(type==2){
		$("#tab_"+type).css("display","");
		$("#tab_1").css("display","none");
		$("#tab_3").css("display","none");
		$("#tab_4").css("display","none");
	}else if(type==3){
		$("#tab_"+type).css("display","");
		$("#tab_2").css("display","none");
		$("#tab_1").css("display","none");
		$("#tab_4").css("display","none");
	}else{
		$("#tab_"+type).css("display","");
		$("#tab_1").css("display","none");
		$("#tab_2").css("display","none");
		$("#tab_3").css("display","none");
	}
}

//标记
function mark(){
	var range = Editor._getCurrentRange();
	var s = null;
    if(range.text == "undefined" || range.text == undefined){
    	s = range;
    }else{
    	s = range.text;
    }
	Editor._insertRangeHtml(range, '<font style="background-color:yellow; ">'+s+'</font>');
}

//取消标记
function unmark(){
	var range = Editor._getCurrentRange();
	var s = null;
    if(range.text == "undefined" || range.text == undefined){
    	s = range;
    }else{
    	s = range.text;
    }
	Editor._insertRangeHtml(range, '<font style="background-color:white; ">'+s+'</font>');
}

//输入法
function languge(){
	$("#toolbar_pop").css("display", "");
}

var questionH = 0;
var userOptH = 0;
var textIncDivH = 0;
var textareaIframeH = 0;
//恢复窗口，type：top上面的按钮，bot下面的按钮；zoomIndex：1主观题，2大题套小题主观题
function zoomSml(type){
	$(".question").css("display", "");
	$(".user-opt").css("display", "");

	$(".question").animate({height: questionH+"px"}, 1000, function(){
		$(".user-opt").animate({height: userOptH+"px"}, 1000);
		$(".text_inc_div").css("height", textIncDivH+"px");
		$(".text_inc_div > div").css("height", textareaIframeH+"px");
	});

	if(type=='bot'){
		$("#zooms_").css("display","none");
		$("#zoomb_").css("display","");
		$("#zooms").css("display","none");
		$("#zoomb").css("display","");
    }else if(type=='top'){
		$("#zoomb_").css("display","");
		$("#zooms_").css("display","none");
		$("#zoomb").css("display","");
		$("#zooms").css("display","none");
	}
}

//放大窗口，type：top上面的按钮，bot下面的按钮；zoomIndex：1主观题，2大题套小题主观题
function zoomBig(type){
	var zoomIndex = $("#zoomIndex").val();

	questionH = $(".question").height();
	userOptH = $(".user-opt").height();
	textIncDivH = $(".text_inc_div").eq(0).height();
	textareaIframeH = $(".text_inc_div").eq(0).children().eq(0).height();

	if(type=='bot'){
		$(".question").animate({height:"0px"},1000,function(){
			$(".question").css("display","none");
		});
		if(zoomIndex == '1'){
			$(".user-opt").animate({height:"379px"},1000);
			$(".text_inc_div").css("height","300px");
			$(".text_inc_div > div").css("height", "270px");
		}else if(zoomIndex == '2'){
			$(".user-opt").animate({height: "348px"}, 1000);
			$(".text_inc_div").css("height", "260px");
			$(".text_inc_div > div").css("height", "230px");
		}

		$("#zoomb_").css("display","none");
		$("#zooms_").css("display","");
		$("#zoomb").css("display","none");
		$("#zooms").css("display","");
	}else if(type=='top'){
		$(".question").animate({height: "379px"}, 1000);
		$(".user-opt").animate({height: "0px"}, 100, function(){
			$(".user-opt").css("display","none");
		});

		$("#zooms_").css("display","");
		$("#zoomb_").css("display","none");
		$("#zooms").css("display","");
		$("#zoomb").css("display","none");
	}
}
var t;//解决闪烁问题
//隐藏拼音等
function moveOutc(flag){
	clearTimeout(t);
	t = setTimeout(function(){
		if(flag == 1){
			$("#toolbar_pop").css("display","none");
		}else if(flag == 0){
			$("#box_div_editor_client1").css("display","none");
		}else{
			
	        $("#box_div_editor_client").css("display","none");
			
		}
	},500);
}

//显示拼音等
function moveOn(flag){
	if( t != null ){
		clearTimeout(t);
	}
	t = null;
	if(flag == 1){
		$("#toolbar_pop").css("display","");
	}else if(flag == 0){
		$("#box_div_editor_client1").css("display","");
	}else{
		$("#box_div_editor_client").css("display","");
	}
}

//显示公式编辑器
function showEquation() {
	$("#box_div_editor_client").css("display","block");
}

//复制
function copyEditor(){
	ATA.item.copy_b();
}

//粘贴
function pasteEditor(){
	ATA.item.paste();
}

//剪切
function cutEditor(){
	ATA.item.cut();
}
//单击公式编辑器里的某个公式
function insertWrite(arg1, arg2){
	Editor.InsertWrite(arg1, arg2);
	$("#box_div_editor_client").css("display","none");
}

//单击矩阵中的某一个选项
function InsertMatrix(arg1, arg2, questionID){
	Editor.InsertMatrix(arg1,arg2);
	$("#box_div_editor_client1").css("display", "none");
	$("#textarea_"+questionID+"_iframe").removeAttr("contentEditable");
	if(questionID != ''){
		$(".Matrix").bind("focus",function(){
			$("#textarea_"+questionID+"_iframe").removeAttr("contentEditable");
		});
		$(".MatrixDiv").bind("blur",function(){
			$("#textarea_"+questionID+"_iframe").attr({contenteditable:"true"});
			$("#textarea_"+questionID+"_iframe").focus();
		});
	}
}

//保存主观题
function sendValue(questionID){
	var str = $(document).find("#textarea_"+questionID+"_iframe").html();
	if(str != null){
		str = acountingTextareaContent(str);
		$("#textarea_"+questionID).val(str);
	}
}

//切换选项卡
function setTab1(n){
	$(".quesInfo").each(function(i){
		if(i == n){
			$(this).css("display", "block");
		}else{
			$(this).css("display", "none");
		}
	});
	$(".ul-more").find("li").eq(n).addClass("hover").siblings().removeClass("hover");

	var serialNum = $("#serialNum").val();
	var quesShow = paperShow.getQuesShow(serialNum);
	var childQuesIDs = quesShow.childQuesIDs;
	var childQuestionIDArr = childQuesIDs.split(",");
	setTimeout(function(){
		var quesid = childQuestionIDArr[n];
		Editor.ChangeContainer("textarea_"+quesid+"_iframe");
	}, 500);
}

//切换公式页签
function setTab(name, cursel, n, evt) {
	setTimeout(function() {
		for (var i = 1; i <= n; i++) {
			var menu = document.getElementById(name + i);
			var con = document.getElementById("con_" + name + "_" + i);
			menu.className = i == cursel ? "hover" : "";
			con.style.display = i == cursel ? "block" : "none";
		}
	}, 200);
}

function copyMEditor(){
	var sel_str = clipboardData.getData("Text");
	ATA.util.storage.set('KEY_COPY_STR', sel_str);
}

//把文本题的用户答案置入编辑框
function setATAtextValue(questionIDs){
	if(questionIDs != null && questionIDs != ''){
		var questionIDArr = questionIDs.split(",");
		for(var i=0; i<questionIDArr.length; i++){
			var questionID = questionIDArr[i];
			var qz = parent.paperShow.getUserAnsByQuestionID(questionID);
			var userAnswer = qz.userAnswer;

			if(userAnswer == null || userAnswer == ""){
				//当js对象里没有用户答案时，要考虑该题目是否有补充答案，补充答案是直接写在$("#ttextare_atainit_"+questionID)里的
				userAnswer = $("#textare_atainit_"+questionID).html();
				if(userAnswer == null || userAnswer == ""){
					userAnswer = "";
				}
			}

			var div_id = "textarea_"+questionID+"_iframe";
			$("#textarea_"+questionID).val(userAnswer);
			$("#"+div_id).html(userAnswer);
		}
	}
}
